# Ultralytics YOLO 🚀, AGPL-3.0 license

import torch
import numpy as np
import os

from PIL import Image

from ultralytics.yolo.engine.predictor import BasePredictor
from ultralytics.yolo.engine.results import Results
from ultralytics.yolo.utils import DEFAULT_CFG, ROOT, ops


class DetectionPredictor(BasePredictor):

    def postprocess(self, preds, img, orig_imgs):
        """Postprocesses predictions and returns a list of Results objects."""
        preds = ops.non_max_suppression(preds,
                                        self.args.conf,
                                        self.args.iou,
                                        agnostic=self.args.agnostic_nms,
                                        max_det=self.args.max_det,
                                        classes=self.args.classes)
        results = []
        for i, pred in enumerate(preds):
            orig_img = orig_imgs[i] if isinstance(orig_imgs, list) else orig_imgs
            if not isinstance(orig_imgs, torch.Tensor):
                pred[:, :4] = ops.scale_boxes(img.shape[2:], pred[:, :4], orig_img.shape)
            path = self.batch[0]
            img_path = path[i] if isinstance(path, list) else path
            results.append(Results(orig_img=orig_img, path=img_path, names=self.model.names, boxes=pred))
        # print('results2222222', results)
        return results

    def boxesMov_output(self, path, img_MovBoxes):
        if len(img_MovBoxes) != 0:
            ##保存判断为运动框中最后十帧所有运动框
            MovBox_save = self.save_dir / 'real_MovBox/'
            if not os.path.exists(MovBox_save):
                MovBox_save.mkdir(parents=True, exist_ok=True)
            # print('img_MovBoxes', img_MovBoxes)
            img_MovBoxes.sort(key=lambda x: x[0], reverse=True)  ##按照ID降序
            index = np.unique(np.array(img_MovBoxes, dtype=object)[:, 0])  ##保留所有运动框的ID,升序排序
            # print('index', index)
            if len(index) > 10:
                real_MovBox = [box for box in img_MovBoxes if box[0] > index[-11]]
            else:
                real_MovBox = [box for box in img_MovBoxes]
            num = 0
            for mv_box in real_MovBox:
                num += 1
                # img_crop = str(MovBox_save) + '\\' + str(video_num) + '_'+ str(i) + '.jpg'
                # img_crop = str(MovBox_save) + '\\' + str(path).split('.mp4')[0].split('\\')[-1] + \
                #            str(mv_box[0]) + '_' + str(num) + '.jpg'
                img_crop = str(MovBox_save) + '/' + str(path).split('.mp4')[0].split('\\')[-1] + '_' + str(
                    mv_box[0]) + '_' + str(num) + '.jpg'
                Image.fromarray(mv_box[1]).save(img_crop, quality=95, subsampling=0)
            # print("99999999999999", real_MovBox)
            return real_MovBox
        else:
            return None

def predict(cfg=DEFAULT_CFG, use_python=False):
    """Runs YOLO model inference on input image(s)."""
    model = cfg.model or 'yolov8n.pt'
    source = cfg.source if cfg.source is not None else ROOT / 'assets' if (ROOT / 'assets').exists() \
        else 'https://ultralytics.com/images/bus.jpg'

    args = dict(model=model, source=source)
    if use_python:
        from ultralytics import YOLO
        YOLO(model)(**args)
    else:       
        predictor = DetectionPredictor(overrides=args)
        predictor.predict_cli()


if __name__ == '__main__':
    predict()
